#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>

int quads(long a, long b)
{
	if (a < 2|| b < 2)
	{
		if (a == b)
			return 1;
		return 0;
	}

	if (a == b)
	{
		if (a % 2 == 0)
		{
			long c = a / 2;
			return quads(c, c) * 4;
		}

		long c = a / 2;
		long b = a - c;
		return
			quads(c, c) +
			quads(c, b) * 2 +
			quads(b, b);
	}

	long ca = a / 2;
	long da = a - ca;

	long cb = b / 2;
	long db = b - cb;

	return
		quads(ca, cb) +
		quads(ca, db) +
		quads(da, cb) +
		quads(da, db);
}

int main()
{
	long a, b;
	std::cin >> a >> b;

	std::cout << quads(a, b);
	return 0;
}