#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <fstream>
using namespace std;
const int N = 1001;
bool use[N], mas[N][N];
int n, st[N];
vector <int> v[N];

void dfs (int s, int i){
    if (use[s]) return;
    use[s] = 1;
    v[i].push_back(s);
    for (int j = 0; j < n; j++){
        if (mas[s][j]) dfs(j, i);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int m, p1, p2, k;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        cin >> p1 >> p2;
        mas[p1 - 1][p2 - 1] = 1;
        mas[p2 - 1][p1 - 1] = 1;
    }
    cin >> k;
    for (int i = 0; i < k; i++){
        cin >> st[i];
        st[i]--;
        use[st[i]] = 1;
    }
    for (int i = 0; i < k; i++){
        use[st[i]] = 0;
        dfs(st[i], i);
    }
    for (int i = 0; i < k; i++){
        cout << v[i].size() << endl;
        for (auto x : v[i]){
            cout << x + 1 << ' ';
        }
        cout << endl;
    }

    return 0;
}