#include <stdio.h>
#include <assert.h>
#include <inttypes.h>
#include <algorithm>
#include <vector>

const int N = 2000;

std::vector<int> gr[N];
int caps[N];
char is_cap[N];
char used[N];

std::vector<int> have[N];

void dfs(int v, int cap) {
    used[v] = true;
    if (is_cap[v])
        cap = v;
    have[cap].push_back(v);
    for (int u : gr[v])
        if (!used[u])
            dfs(u, cap);
}

int main() {

    int n, m;
    scanf("%d%d", &n, &m);

    for (int i = 0; i < m; ++i) {
        int a, b; scanf("%d%d", &a, &b); --a, --b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }

    int k; scanf("%d", &k);

    for (int i = 0; i < k; ++i)
        scanf("%d", caps+i), caps[i]--,
        is_cap[caps[i]] = true;

    dfs(caps[0], caps[0]);

    for (int i = 0; i < k; ++i) {
        printf("%d\n", (int)have[caps[i]].size());
        for (int v : have[caps[i]])
            printf("%d ", v+1);
        printf("\n");
    }

    return 0;
}
