#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <algorithm>
#include <vector>
#include <string>

const int N = 2e8;

int first_not_used = 1;
char used[N];

void set_used(int i) {
    used[i] = true;
    while (first_not_used < N && used[first_not_used])
        first_not_used++;
}

int arr[N];

int main() {

    int n; scanf("%d", &n);
    arr[0] = 0;
    for (int i = 1; i < n; ++i) {
        arr[i] = arr[i-1] + first_not_used;
        for (int j = 0; j < i; ++j)
            set_used(arr[i] - arr[j]);
    }

    for (int i = 0; i < n; ++i)
        printf("%d ", arr[i]);
    //intf("%d", arr[n-1]);

    return 0;
}
