#include <stdio.h>
#include <assert.h>
#include <inttypes.h>
#include <algorithm>

int solve(int w, int h) {
    if (w > h)
        std::swap(w, h);
    if (h == 1)
        return 1;
    if (w*3 == h)
        return 3;
    if (w*2 == h)
        return 2;
    if (w == h)
        return (w&1) ? 2 : 4;
    if (!(w&1))
        return 2;
    if (!(h&1) && h/2 < w)
        return 2;
    return 1;
}

int main() {

    int w, h;
    scanf("%d%d", &w, &h);

    printf("%d\n", solve(w, h));

    return 0;
}
