#include <stdio.h>
#include <assert.h>
#include <inttypes.h>
#include <algorithm>

int upd_max(int& mx, const int& val) {
    if (val > mx)
        mx = val;
    return mx;
}

int solve(int w, int h) {
    if (w > h)
        std::swap(w, h);
    if (h == 1)
        return 1;
    int ans = 1;
    if (w*3 == h)
        upd_max(ans, 3);
    if (w*2 < h)
        upd_max(ans, 2);
    if (w == h)
        upd_max(ans, (w&1) ? 2 : 4);
    if (!(w&1))
        upd_max(ans, 2);
    if (!(h&1) && h/2 < w)
        upd_max(ans, 2);

    return ans;
}

int main() {

    int w, h;
    scanf("%d%d", &w, &h);

    printf("%d\n", solve(w, h));

    return 0;
}
