#include <stdio.h>
#include <assert.h>
#include <inttypes.h>
#include <algorithm>

#define int int64_t

int upd_max(int& mx, const int& val) {
    if (val > mx)
        mx = val;
    return mx;
}

int solve_v(int w, int h) {
    if (w*3 == h)
        return 3;
    if (w*2 <= h)
        return 2;
    if (w <= h)
        return 1;
    return 0;
}

inline
int try_split(int w, int h, int a, int c) {
    int b = w-a;
    int d = h-b;
    if (a < 0 || b < 0 || c < 0 || d < 0)
        return -1;
    return (a && c && a == c)
         + (a && d && a == d)
         + (b && c && b == c)
         + (b && d && b == d);
}

int solve_vg(int w, int h) {
    int ans = 0;
    upd_max(ans, try_split(w, h, w/2, w/2));
    upd_max(ans, try_split(w, h, w/2, h/2));
    upd_max(ans, try_split(w, h, h/2, w/2));
    upd_max(ans, try_split(w, h, h/2, h/2));

    return ans;
}

signed main() {

    int w, h;
    scanf("%lld%lld", &w, &h);

    printf("%lld\n", std::max(std::max(solve_v(w, h) , solve_v(h, w) ),
                              std::max(solve_vg(w, h), solve_vg(h, w))));

    return 0;
}
