#include <iostream>
#include <map>
#include <vector>
#include <string>

using namespace std;

const int INF = 1e9;
const int mn = 262144;
int i, n, k, r, x, fst = 1, d, n1, num, i1, i2;
vector <int> a(mn), b(mn), c(mn, INF), e(mn, INF);
string s, s1;

void init()
{
	for (int i = fst - 1; i > 0; i--)
		a[i] = a[2 * i] + a[2 * i + 1],
		c[i] = min(c[2 * i], c[2 * i + 1]);
}

int get(int i)
{
	int ans = a[i];
	while (i)
	{
		if (e[i] < INF) ans = e[i];
		ans += b[i];
		i/= 2;
	}
	return ans;
}

void push(int k, int d)
{
	int l = 2 * k, r = 2 * k + 1, add = b[k], u = k << d, v = u | ((1 << d)-1), cnt = min(v, fst+n-1)-u+1;
	a[k]+= add*cnt;
	b[k] = 0;
	c[k] += add;
	if (d){
		if (e[l] < INF)
			e[l] += add;
		else
			b[l] += add;
		if (e[r] < INF)
			e[r] += add;
		else
			b[r] += add;
	}
	if (e[k] < INF)
	{
		a[k] = e[k] * cnt;
		c[k] = e[k];
		if (d)
		{
			b[l] = b[r] = 0;
			e[l] = e[r] = e[k];
		}
		e[k] = INF;
		}
}

void update(int i, int d, int l, int r, int x)
{
	int u = i << d, v = u | ((1 << d)-1);
	push(i, d);
	if (v < l|| u > r)
		return;
	if (l <= u && v <= r)
		e[i] = x, push(i, d);
	else
	{
		update(2 * i, d - 1, l, r, x);
		update(2 * i + 1, d - 1, l, r, x);
		a[i] = a[2 * i] + a[2 * i + 1];
		c[i] = min(c[2 * i], c[2 * i + 1]);
	}
}

int rsq(int i, int d, int l, int r)
{
	int u = i << d, v = u | ((1 << d) - 1);
	push(i, d);
	if (v < l || u > r)
		return 0;
	if (l <= u && v <= r)
		return a[i];
	return rsq(2 * i, d - 1, l, r) + rsq(2 * i + 1, d - 1, l, r);
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	n = 1e5;
	while (fst < n)
		fst *= 2, d++;
	//for (i = fstl i < fst + n; i++)

	init();

	cin >> n1;

	for (i1 = 0; i1 < n1; i1++)
	{
		cin >> s1 >> num;
		if (s1 == "add") 
		{
			if (get(fst + num) == 0)
				update(1, d, num +fst ,fst +  num , 1);
			else
			{
				int o1;
				for (i2 =  num - 1;;i2++)
				{
					if (get(i2) == 0){
						o1 = i2;
						break;
					}
				}
				update(1, d, fst + num , fst + o1, 0);
				update(1, d, fst + o1 + 1, fst + o1 + 1, 1);
			}
			cout << rsq(1, d, fst + 0, fst + 1e5) << endl;
		}
		if (s1 == "sub")
		{
			if (get(fst + num) == 1)
				update(1, d, fst +num, fst +num, 0);
			else
			{
				int o1;
				for (i2 = num -1;;i2++)
				{
					if (get(fst + i2 ) == 1){
						o1 = i2;
						break;
					}
				}
				update(1, d, fst + num, fst + o1, 1);
				update(1, d, fst + o1 + 1, fst + o1 + 1, 0);
			}
			cout << rsq(1, d, fst + 0, fst + 1e5) << endl;
		}
	}

	return 0;
}