#include <stdio.h>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds; */

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define isz(x) (int)(x).size()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef pair<int, int> pii;

/* <--------------------------------------------------> */

const int MX = 2e5 + 1;
int cnt[MX];

int get_h(int a)
{
    ll ans = 1;
    for (int i = 2; a > 1; ++i)
    {
        if (i * i > a) i = a;
        if (!(a % i))
        {
            int q = 0;
            while (!(a % i))
            {
                ++q;
                a /= i;
            }
            if (q & 1) ans *= 1LL * i;
        }
    }
    return ans;
}

void solve()
{
    int n;
    ll ans = 0;
    scanf("%d", &n);
    forn (i, n)
    {
        int a;
        scanf("%d", &a);
        int h = get_h(a);
        ans += 1LL * cnt[h];
        ++cnt[h];
    }
    printf("%lld", ans);
}

/* <--------------------------------------------------> */

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    //cin.tie(0);

    solve();

    return 0;
}
