#include <bits/stdc++.h>

using namespace std;
const int  maxn = 1e3 + 7;
vector <vector <int>> adj_list;
vector <int> ans;
bool used[maxn];

set <int> s;

void dfs(int v) {
    used[v] = true;
    ans.push_back(v);
    for (auto u : adj_list[v]) {
        if (!used[u] && !s.count(u)) {
            dfs(u);
        }
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    adj_list.resize(n + 1);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        adj_list[a].push_back(b);
        adj_list[b].push_back(a);
    }
    int k;
    cin >> k;
    vector <int> v;
    for (int i = 0; i < k; ++i) {
        int a;
        cin >> a;
        v.push_back(a);
        s.insert(a);
    }
    for (int i = 0; i < k; ++i) {
        if (!used[v[i]]) {
            ans.clear();
            dfs(v[i]);
        }
        cout << ans.size() << endl;
        for (int j = 0; j < ans.size(); ++j) {
            cout << ans[j] << " ";
        }
        cout << endl;
    }
    return 0;
}
