#include <iostream>
#include <algorithm>
#include <string>

std::string ltos(long a)
{
	std::string str = "";
	if (a < 0) {
		str = "-";
		a = -a;
	}
	for (; a; a /= 10)
		str = char((a % 10) + '0') + str;
	return str;
}

int main()
{
	long a;
	std::cin >> a;
	if (a % 2 == 0)
	{
		std::string b = ltos(a - 1);
		std::string c = ltos(a + 1);

		if (c.length() > b.length())
			std::cout << b;
		else
			std::cout << c;
	}
	else
		std::cout << a;
	return 0;
}