#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>

bool isQuad(long a)
{
	int n = sqrtl(a) + 1;
	for (int i = 0; i < n; ++i)
		if (i * i == a)
			return true;
	return false;
}

int main()
{
	long n = 0;
	long* bobrs;

	std::cin >> n;
	bobrs = new long[n];
	for (int i = 0; i < n; ++i)
		std::cin >> bobrs[i];


	long total = 0;
	for (int i = 0; i < n; ++i)
		for (int j = n - 1; j > i; --j)
			total += isQuad(bobrs[i] * bobrs[j]);
	std::cout << total;

	return 0;
}