#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>

bool isQuad(long a)
{
	int n = sqrtf(a) + 1;
	for (int i = n; i; --i)
		if (i * i == a)
			return true;
	return false;
}

int main()
{
	int n = 0;
	int* bobrs;

	std::cin >> n;
	bobrs = new int[n];
	for (int i = 0; i < n; ++i)
		std::scanf("%i", bobrs + i);


	long total = 0;
	for (int i = 0; i < n; ++i)
		for (int j = n - 1; j > i; --j)
			total += isQuad(bobrs[i] * bobrs[j]);
	std::cout << total;

	return 0;
}