#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>

int quads(long a, long b)
{
	if (a == 0 || b == 0)
		return 0;
	if (a == 1 || b == 1)
	{
		if (a == b)
			return 1;
		return 0;
	}

	long ca = a / 2;
	long da = a - ca;

	long cb = b / 2;
	long db = b - cb;

	return
		quads(ca, cb) +
		quads(ca, db) +
		quads(da, cb) +
		quads(da, db);
}

int main()
{
	long a, b;
	std::cin >> a >> b;

	std::cout << quads(a, b);
	return 0;
}