#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>

int quads(long a, long b)
{
	if (a < 2|| b < 2)
	{
		if (a == b)
			return 1;
		return 0;
	}

	long c = 1;
	
	if (a == b)
	{
		for (; a % 2 == 0 && a > 2; a /= 2)
			c *= 4;
		b = a;
	}

	long ca = a / 2;
	long da = a - ca;

	long cb = b / 2;
	long db = b - cb;

	return (
		quads(ca, cb) +
		quads(ca, db) +
		quads(da, cb) +
		quads(da, db)
		) * c;
}

int main()
{
	long a, b;
	std::cin >> a >> b;

	std::cout << quads(a, b);
	return 0;
}