#include <iostream>
#include <vector>

using namespace std;

bool is2powered(unsigned int number)
{
    if (number < 2) return false;
    unsigned int i = 2, b = number + 1;
    while (true)
    {
        if (number % i == 0) b = number / i;
        if (i == b) return true;
        if (i > b) return false;
        i++;
        b = number + 1;
    }
}

int main()
{
    vector <unsigned int> s;
    int N;
    cin >> N;
    for (int i = 0; i < N; i++)
    {
        unsigned int siz;
        cin >> siz;
        s.push_back(siz);
    }

    int c = 0;
    for (int i = 0; i < N; i++)
    {
        for (int j = i + 1; j < N; j++)
        {
            if (is2powered(s[i] * s[j])) c++;
        }
    }
    cout << c;

    return 0;
}