#include <iostream>
#include <vector>

using namespace std;

int n, m;
bool g[1005][1005], used[1005];
vector < vector <int> > main1;
vector <int> capitals;

void dfs(int v, int main_v)
{
    used[v] = true;
    main1[main_v].push_back(v);
    for (int i = 0; i < n; ++i)
        if(!used[i] && g[v][i]) dfs(i, main_v);
}

int main()
{
    cin >> n >> m;
    main1.resize(n);
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x][y] = true;
        g[y][x] = true;
    }
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i)
    {
        int x;
        cin >> x;
        x--;
        used[x] = true;
        capitals.push_back(x);
    }
    for (int i = 0; i < (int)capitals.size(); ++i)
    {
        int main_v = capitals[i];
        dfs(main_v, main_v);
    }
    for (int i = 0; i < k; ++i)
    {
        int main_v = capitals[i];
        cout << (int)main1[main_v].size() << endl;
        for (int j = 0; j < (int)main1[main_v].size(); ++j)
            cout << main1[main_v][j] + 1 << ' ';
        cout << endl;
    }
    return 0;
}
