#include <stdio.h>
#include <assert.h>
#include <inttypes.h>
#include <algorithm>

const int N = 200000;

int cnt[N];

int main() {

    int n; scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        int x; scanf("%d", &x);
        int j;
        for (j = 2; j*j <= x; ++j)
            while (x%(j*j) == 0)
                x /= (j*j);
        cnt[x]++;
    }

    int64_t ans = 0;
    for (int i = 1; i <= N; ++i)
        ans += (int64_t)cnt[i]*(cnt[i]-1)/2;

    printf("%lld\n", ans);

    return 0;
}
