#include <iostream>
#include <map>
#include <vector>
#include <set>

using namespace std;

int n, m, k, i, j, x, y;
vector<vector<int>> a;
vector<int> us;
map<int, int> mp;
set<int> caps;
map<int, vector<int>> mp1;

int dfs(int u, int capital)
{
	if (mp.count(u))
		return 0;
	mp[u] = capital;
	for (int i = 0; i < a[u].size(); i++)
	{
		if (caps.count(a[u][i]))
			continue;
		dfs(a[u][i], capital);
	}
	return 1;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n >> m;

	a.resize(n);
	for (i = 0; i < m; i++)
	{
		cin >> x >> y;
		x--;
		y--;
		a[x].push_back(y);
		a[y].push_back(x);
	}

	cin >> k;
	for (i = 0; i < k; i++)
	{
		cin >> x;
		x--;
		us.push_back(x);
		caps.insert(x);
	}

	for (i = 0; i < k; i++)
	{
		dfs(us[i], us[i]);
	}

	for (auto h : mp)
	{
		mp1[h.second + 1].push_back(h.first + 1);
	}

	for (auto h : mp1)
	{
		cout << h.second.size() << endl;
		for (auto o : h.second)
			cout << o << " ";
		cout << endl;
	}

	return 0;
}