#include <stdio.h>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds; */

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define isz(x) (int)(x).size()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef pair<int, int> pii;

/* <--------------------------------------------------> */

const int MX = 103;
string t[MX][MX], s;
int len[MX], mx, col[MX]; //len of string, maximal len of string, maximal len in this column

void solve()
{
    int i = 0;
    while (getline(cin, s))
    {
        int n = isz(s), cnt = 0;
        for (int j = 0; j < n; )
        {
            bool kv = false;
            if (s[j] == '"')
            {
                int k = j + 1;
                while (k < n && s[k] == '"') ++k;
                if ((k - j) & 1) kv = true;
            }
            if (kv) ++j;
            while (j < n)
            {
                if (s[j] == ',')
                {
                    if (kv)
                    {
                        t[i][cnt].pb(s[j]);
                        ++j;
                    }
                    else
                    {
                        ++j;
                        break;
                    }
                }
                else if (s[j] == '"' && kv)
                    {
                        if (j != n - 1 && s[j + 1] == '"')
                        {
                            t[i][cnt].pb('"');
                            j += 2;
                        }
                        else
                        {
                            j += 2;
                            break;
                        }
                    }
                else
                {
                    t[i][cnt].pb(s[j]);
                    ++j;
                }
            }
            col[cnt] = max(col[cnt], isz(t[i][cnt]));
            ++cnt;
        }
        len[i] = cnt;
        mx = max(mx, cnt);
        ++i;
    }

    forn (_i, i)
    {
        forn (j, mx)
        {
            cout << t[_i][j];
            int left = col[j] - isz(t[_i][j]);
            while (left--) cout << " ";
            if (j != mx - 1) cout << "|";
        }
        cout << endl;
    }
}

/* <--------------------------------------------------> */

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    //cin.tie(0);

    solve();

    return 0;
}
