#include <stdio.h>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds; */

#define pb push_back
#define ft first
#define sd second
#define all(x) begin((x)), end((x))
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define isz(x) (int)(x).size()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef pair<int, int> pii;

/* <--------------------------------------------------> */

const int MX = 1e3 + 7;

vector<int> g[MX], ans[MX];
int c[MX];
bool us[MX];

void dfs(int v, int cap)
{
    ans[cap].pb(v);
    us[v] = true;
    for (int & u : g[v]) if (!us[u])
        dfs(u, cap);
}

void solve()
{
    int n, m, k;
    scanf("%d%d", &n, &m);
    forn (i, m)
    {
        int v, u;
        scanf("%d%d", &v, &u);
        g[v - 1].pb(u - 1);
        g[u - 1].pb(v - 1);
    }
    scanf("%d", &k);
    forn (i, k)
    {
        scanf("%d", c + i);
        --c[i];
        us[c[i]] = true;
    }
    forn (i, k) dfs(c[i], c[i]);
    forn (i, k)
    {
        printf("%d\n", isz(ans[c[i]]));
        for (int & j : ans[c[i]]) printf("%d ", j + 1);
        puts("");
    }
}

/* <--------------------------------------------------> */

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
