#include <iostream>
#include <vector>

using namespace std;
vector<int> g[1000], c, r[1000];
bool used[1000];

void DFS(int cn, int v)
{
    used[v] = true;
    r[cn].push_back(v);
    for (int i = 0; i < g[v].size(); ++i)
        if (!used[g[v][i]])
        DFS(cn, g[v][i]);
}

int main()
{
    int n, m, u, v;
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v), g[v].push_back(u);
    }
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i)
        cin >> u, --u, c.push_back(u), used[u] = true;
    for (int i = 0; i < k; ++i)
        DFS(i, c[i]);
    for (int j = 0; j < k; ++j)
    {
        cout << r[j].size() << endl;
        for (int i = 0; i < r[j].size(); ++i)
            cout << r[j][i] + 1 << ' ';
        cout << endl;
    }
}
